dynamic_predicate(vertex,1).
dynamic_predicate(edge,2).
dynamic_predicate(mark,2).

tabled_predicate(hamiltonian_cycle,2).

% tr_clause(+Head,+Body) - Hamiltonian cycle: a cycle that traverses all vertexes without using the same vertex twice.
tr_clause(
	hamiltonian_cycle(Start,Start),
	not(vertex(_))
).
tr_clause(
	hamiltonian_cycle(Start,X),
	seq( edge(X,Y),
		seq( vertex(Y),
			seq( del(vertex(Y)),
				seq( ins(mark(X,Y)),
					seq( hamiltonian_cycle(Start,Y),
						ins(vertex(Y))
					)
				)
			)
		)
	)
).
